unit MainTCP;

interface

{uses
  Windows, Classes, Controls, Forms, StdCtrls, ExtCtrls, ComCtrls,
  CheckLst, SimpleTCP;
 }
 
var //type
  //TForm1 = class(TForm)
    Server: TSimpleTCPServer;
    Client1: TSimpleTCPClient;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    ServerPortLab: TLabel;
    ListenBox: TCheckBox;
    GroupBox4: TGroupBox;
    GroupBox2: TGroupBox;
    Panel4: TPanel;
    Client1HostLab: TLabel;
    Client1PortLab: TLabel;
    Client1HostEdit: TEdit;
    Client1PortEdit: TEdit;
    Connected1Box: TCheckBox;
    GroupBox5: TGroupBox;
    GroupBox3: TGroupBox;
    Client2HostLab: TLabel;
    Client2PortLab: TLabel;
    Client2HostEdit: TEdit;
    Client2PortEdit: TEdit;
    Connected2Box: TCheckBox;
    GroupBox6: TGroupBox;
    Client2: TSimpleTCPClient;
    ConnectionsLab: TLabel;
    ServerOutput: TMemo;
    Client1Output: TMemo;
    Client2Output: TMemo;
    ServerInput: TEdit;
    Client1Input: TEdit;
    Client2Input: TEdit;
    ServerPortEdit: TEdit;
    StatusBar1: TStatusBar;
    GroupBox7: TGroupBox;
    LogBox: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SendToBox: TCheckListBox;
    procedure TForm1ListenBoxClick(Sender: TObject);
    procedure TForm1Connected1BoxClick(Sender: TObject);
    procedure TForm1Connected2BoxClick(Sender: TObject);
    procedure TForm1ServerError(Sender: TObject; Socket, ErrorCode: Integer;
      ErrorMsg: String);
    procedure TForm1ServerAccept(Sender: TObject; Client: TSimpleTCPClient;
      var Accept: Boolean);
    procedure TForm1ServerClientConnected(Sender: TObject;
      Client: TSimpleTCPClient);
    procedure TForm1ServerClientDisconnected(Sender: TObject;
      Client: TSimpleTCPClient);
    procedure TForm1Client1Connected(Sender: TObject);
    procedure TForm1Client1Disconnected(Sender: TObject);
    procedure TForm1ServerInputKeyPress(Sender: TObject; var Key: Char);
    procedure TForm1Client1InputKeyPress(Sender: TObject; var Key: Char);
    procedure TForm1Client2InputKeyPress(Sender: TObject; var Key: Char);
    procedure TForm1FormShow(Sender: TObject);
    procedure TForm1ServerClientRead(Sender: TObject; Client: TSimpleTCPClient;
      Stream: TStream);
    procedure TForm1Client1Read(Sender: TObject; Stream: TStream);
  //private
    procedure TForm1Log(Sender: TObject; St: String);
  //public
  //end;

var
  Form1: TForm; //TForm1;

implementation

//{$R *.DFM}

//uses SysUtils;

procedure TForm1FormShow(Sender: TObject);
begin
  Client1HostEdit.Text := Server.LocalIP;
end;

function EnDeCrypt(const Value : String) : String;
var
  CharIndex : integer;
begin
  Result := Value;
  for CharIndex := 1 to Length(Value) do
    Result[CharIndex] := chr(not(ord(Value[CharIndex])));
end;

procedure TForm1Log(Sender: TObject; St: String);
var
  I: Integer;
  Name: String;
  tmpClient: TSimpleTCPClient;
  tmpobj: TObjectlist;
  ap: _pointer;
begin
  Name := TComponent(Sender).ClassName;
  if TComponent(Sender).Tag <> 0 then Name := 
     Name + ' [' + IntTOStr(TComponent(Sender).Tag) + ']';

  LogBox.Items.Add(Name + ' - ' + St);
  //MAXIMUM_WAIT_OBJECTS

  LogBox.ItemIndex := LogBox.Items.Count - 1;
  
  //RaiseListError
  //ipconfig
  //pointer

  ConnectionsLab.Caption := 'Connections: ' + IntToStr(Server.Connections2.Count);
  SendToBox.Clear;
  I := Server.Connections2.Count;
  if I <> 0 then
   for I := 0 to I - 1 do  begin
     tmpClient := TSimpleTCPClient(Server.Connections2[i]);
     //tmpClient := TSimpleTCPClient(TObjectlist(Server.Connections).items[i]);
     
     SendToBox.Items.Add(tmpClient.Host + ':' + IntToStr(tmpClient.Port));
     SendToBox.Checked[I] := True;
    end;

  Connected1Box.Checked := Client1.Connected;
  Connected2Box.Checked := Client2.Connected;

  ServerPortLab.Enabled := not Server.Listen;
  ServerPortEdit.Enabled := not Server.Listen;
  Client1HostLab.Enabled := not Client1.Connected;
  Client2HostLab.Enabled := not Client2.Connected;
  Client1HostEdit.Enabled := not Client1.Connected;
  Client2HostEdit.Enabled := not Client2.Connected;
  Client1PortLab.Enabled := not Client1.Connected;
  Client2PortLab.Enabled := not Client2.Connected;
  Client1PortEdit.Enabled := not Client1.Connected;
  Client2PortEdit.Enabled := not Client2.Connected;

  ServerInput.Enabled := Server.Listen;
  Client1Input.Enabled := Client1.Connected;
  Client2Input.Enabled := Client2.Connected;
end;

procedure TForm1ListenBoxClick(Sender: TObject);
begin
  try
    Server.Port := StrToInt(ServerPortEdit.Text);
  except
  end;
  Server.Listen := ListenBox.Checked;

  if Server.Listen then
   TForm1Log(Server, 'Server ready')
  else
   TForm1Log(Server, 'Server shutdown'); 
end;

procedure TForm1Connected1BoxClick(Sender: TObject);
begin
  try
    Client1.Host := Client1HostEdit.Text;
    Client1.Port := StrToInt(Client1PortEdit.Text);
  except
  end;
  Client1.Connected := Connected1Box.Checked;
end;


//intertnal test
procedure TSimpleTCPServerBroadcast(Buffer: PChar; BufLength: Integer);
var
  I: Integer;
  FConnections: TObjectlist;
begin
  I := FConnections.Count;
  if I <> 0 then
   for I := 0 to I - 1 do
    with TSimpleTCPClient(FConnections[I]) do
     //SendBufferTo(FSocket, Buffer, BufLength);
end;

procedure TForm1Connected2BoxClick(Sender: TObject);
begin
  try
    Client2.Host := Client2HostEdit.Text;  
    Client2.Port := StrToInt(Client2PortEdit.Text);
  except
  end;
  Client2.Connected := Connected2Box.Checked;
end;

procedure TForm1ServerInputKeyPress(Sender: TObject; var Key: Char);
var
  St: String;
  i: Integer;
  tmpClient: TSimpleTCPClient;
begin
  if Key = #13 then
   begin
    St := 'Server: ' + ServerInput.Text;

    // Sending to checked clients
    // --
    // btw, if you'd like to send msg to all clients
    // you can use "Broadcast" or "BroadcastStream" methods
    // --
    // Server.Broadcast(PChar(St), Length(St));

//    I := TObjectlist(Server.Connections).Count;
    I := Server.Connections2.Count;

    if I <> 0 then
     for I := 0 to I - 1 do begin
       //tmpClient := TSimpleTCPClient(TObjectlist(Server.Connections).items[I]);
       tmpClient := TSimpleTCPClient(Server.Connections2[I]);
      
       if SendToBox.Checked[I] then
         Server.Send(tmpClient, PChar(St), Length(St));
      end;

    ServerInput.Text := '';
    Key := #0;
   end;
end;

procedure TForm1Client1InputKeyPress(Sender: TObject; var Key: Char);
var
  St: String;
begin
  if Key = #13 then
   begin
    St := 'Client1: ' + Client1Input.Text;
    Client1.Send(PChar(St), Length(St));

    Client1Input.Text := '';
    Key := #0;
   end;
end;

procedure TForm1Client2InputKeyPress(Sender: TObject; var Key: Char);
var
  St: String;
begin
  if Key = #13 then
   begin
    St := 'Client2: ' + Client2Input.Text;
    Client2.Send(PChar(St), Length(St));

    Client2Input.Text := '';
    Key := #0;    
   end;
end;

procedure TForm1ServerError(Sender: TObject; Socket, ErrorCode: Integer;
  ErrorMsg: String);
begin
  TForm1Log(Sender, 'ERROR: ' + ErrorMsg);
end;

procedure TForm1ServerAccept(Sender: TObject; Client: TSimpleTCPClient;
  var Accept: Boolean);
begin
  TForm1Log(Sender, 'Client Accepted:  (' + Client.Host + ')');
end;

procedure TForm1ServerClientConnected(Sender: TObject;
  Client: TSimpleTCPClient);
begin
  TForm1Log(Sender, 'Client  (' + Client.Host + ') connected to server');
end;

procedure TForm1ServerClientDisconnected(Sender: TObject;
  Client: TSimpleTCPClient);
begin
  TForm1Log(Sender, 'Client (' + Client.Host + ') disconnected from server.');
end;

procedure TForm1Client1Connected(Sender: TObject);
begin
  TForm1Log(Sender, 'Client connected.');
end;

procedure TForm1Client1Disconnected(Sender: TObject);
begin
  TForm1Log(Sender, 'Client disconnected.');
end;

procedure TForm1ServerClientRead(Sender: TObject;
  Client: TSimpleTCPClient; Stream: TStream);
var
  St: String;
begin
  TForm1Log(Sender, 'Data received from socket ' + IntToStr(Client.Socket) + ' (' + Client.Host + ')');
  //with TStream(Stream) as TMemoryStream do
  with stream do begin
    SetLength(St, Size);
    Read(St[1], Size);
   end;
  ServerOutput.Lines.Add(St);
end;

procedure TForm1Client1Read(Sender: TObject; Stream: TStream);
var
  St: String;
begin
  TForm1Log(Sender, 'Data received from socket');
  //with Stream as TMemoryStream do
  with stream do 
   begin
    SetLength(St, Size);
    Read(St[1], Size);
   end;

  if Sender = Client1 then  
    Client1Output.Lines.Add(St)
  else
    Client2Output.Lines.Add(St);
end;

end.
